/* lease.h */

#define SODA_SERVER_PORT 65000
#define SODA_CLIENT_PORT 65001

#define HASH_SIZE    103
#define MAX_CLIENTS   20
#define MAX_SHARING    5
#define MAX_HOSTNAME 256

/* MAX_SHARING can be bigger. The unique limitation is the memory occupied by the 
   hash table. Should the sharing get bigger it will be better to use
   a linked list to store the leases for each file. 
*/


#define hash_function(x) ((x)%(HASH_SIZE))

struct lease_table_entry{}; /* prototype */

struct leaseT {
  unsigned long client;    /* owner of the lease   */
  unsigned int expiration; /* expiration timestamp */
};

struct lease_table_entry {
  int psi_node;                  /* pseudo-inode */
  struct leaseT lease[MAX_SHARING+1];
  
  struct lease_table_entry *colision_next,
                           *colision_prev;
};


/**********************************/

struct soquete {
  long client;
  int  sock;
};


struct message {
  int  file;
  int  hostnamesize;
  char hostname[MAX_HOSTNAME];
};


void new_lease(long client, int file, int expiration);
void invalidate_leases(int file);

